namespace View_by_Distance.Shared.Models.Stateless.Methods;

public interface IPerson
{

    // ...

    Dictionary<DateTime, string[]> TestStatic_Split(int personBirthdayFirstYear, string personKeyFormat, string knownPeopleFile) =>
        Split(personBirthdayFirstYear, personKeyFormat, knownPeopleFile);
    static Dictionary<DateTime, string[]> Split(int personBirthdayFirstYear, string personKeyFormat, string knownPeopleFile) =>
        Person.Split(personBirthdayFirstYear, personKeyFormat, knownPeopleFile);

    Models.Person[] TestStatic_GetPeople(Properties.IStorage storage, int personBirthdayFirstYear, string personBirthdayFormat, string personKeyFormat) =>
        GetPeople(storage, personBirthdayFirstYear, personBirthdayFormat, personKeyFormat);
    static Models.Person[] GetPeople(Properties.IStorage storage, int personBirthdayFirstYear, string personBirthdayFormat, string personKeyFormat) =>
        Person.GetPeople(storage, personBirthdayFirstYear, personBirthdayFormat, personKeyFormat);

    void TestStatic_SavePerson(Properties.IStorage storage, string personBirthdayFormat, Models.Person person) =>
        SavePerson(storage, personBirthdayFormat, person);
    static void SavePerson(Properties.IStorage storage, string personBirthdayFormat, Models.Person person) =>
        Person.SavePerson(storage, personBirthdayFormat, person);

    string TestStatic_GetFileFullName(Properties.IStorage storage, string personBirthdayFormat, Models.Person person) =>
        GetFileFullName(storage, personBirthdayFormat, person);
    static string GetFileFullName(Properties.IStorage storage, string personBirthdayFormat, Models.Person person) =>
        PersonBirthday.GetFileFullName(storage, personBirthdayFormat, person.Birthday);

    Models.Person TestStatic_CreatePerson(Properties.IStorage storage, string personBirthdayFormat, Models.PersonBirthday birthday, Models.PersonName name, List<Models.PersonComment> comments, List<Models.PersonURL> urls, List<Models.PersonNumber> numbers, List<Models.PersonEmail> emails, List<Models.PersonAddress> addresses) =>
        CreatePerson(storage, personBirthdayFormat, birthday, name, comments, urls, numbers, emails, addresses);
    static Models.Person CreatePerson(Properties.IStorage storage, string personBirthdayFormat, Models.PersonBirthday birthday, Models.PersonName name, List<Models.PersonComment> comments, List<Models.PersonURL> urls, List<Models.PersonNumber> numbers, List<Models.PersonEmail> emails, List<Models.PersonAddress> addresses) =>
        Person.CreatePerson(storage, personBirthdayFormat, birthday, name, comments, urls, numbers, emails, addresses);

}